/* Let's You change mp_flashlight and mp_footsteps without access to rcon
Thanks to Kndroc and Wraith for help in forums
*/

#include <core>
#include <console>
#include <string>
#include <admin>
#include <adminlib>

//access level for command, you can change as you see fit
#define ACCESS_FOOTSTEPS ACCESS_BAN
#define ACCESS_FLASHLIGHT ACCESS_BAN
#define ACCESS_FORCECHASECAM ACCESS_BAN


/*Switches
Use these if you want to only let admins with proper access level
use one command or the other*/

//Set to 0 to disable admin_footsteps
#define ENABLE_FOOTSTEPS 1

//Set to 0 to disable admin_flashlight
#define ENABLE_FLASHLIGHT 1

//Set to 0 to disable admin_forcechasecam
#define ENABLE_FORCECHASECAM 1

new STRING_VERSION[MAX_DATA_LENGTH] = "3.0.1";

public admin_footsteps(HLCommand, HLData, HLUserName, UserIndex)
{
	new Command[MAX_COMMAND_LENGTH];
	new User[MAX_NAME_LENGTH];
	new Message[MAX_TEXT_LENGTH];
	new Text[MAX_TEXT_LENGTH];
	new iCurVal = 0;
	new iNewVal = 0;
	new sNewVal[MAX_NUMBER_LENGTH]

	convert_string(HLCommand, Command, MAX_COMMAND_LENGTH);
	convert_string(HLUserName, User, MAX_NAME_LENGTH);

	iCurVal = getvar("mp_footsteps");	

	if (iCurVal == 1)
	{
		iNewVal = 0;		
		numtostr(iNewVal, sNewVal)

		snprintf(Message, MAX_TEXT_LENGTH, "%s has turned off footsteps^nBe as loud as you like", User);
		centersay(Message,10,255,0,0);
		say_command(User, Command, sNewVal, 1);
		
		snprintf(Text, MAX_TEXT_LENGTH, "mp_footsteps %s", sNewVal);
		exec(Text);
	}
	else
	{
		iNewVal = 1;
		numtostr(iNewVal, sNewVal);

		snprintf(Message, MAX_TEXT_LENGTH, "%s has turned on footsteps^nStep lightly my son", User);
		centersay(Message,10,255,0,0);
		say_command(User, Command, sNewVal, 1);
		
		snprintf(Text, MAX_TEXT_LENGTH, "mp_footsteps %s", sNewVal);
		exec(Text);
	}
	return PLUGIN_HANDLED;
}

public admin_flashlight(HLCommand, HLData, HLUserName, UserIndex)
{
	new Command[MAX_COMMAND_LENGTH];
	new User[MAX_NAME_LENGTH];
	new Message[MAX_TEXT_LENGTH];
	new Text[MAX_TEXT_LENGTH];
	new iCurVal = 0;
	new iNewVal = 0;
	new sNewVal[MAX_NUMBER_LENGTH];
	
	convert_string(HLCommand, Command, MAX_COMMAND_LENGTH);
	convert_string(HLUserName,User,MAX_NAME_LENGTH);	
	iCurVal = getvar("mp_flashlight")

	if (iCurVal == 1)
	{
		iNewVal = 0;
		numtostr(iNewVal, sNewVal);
		
		snprintf(Message, MAX_TEXT_LENGTH, "%s has turned off your ability^nto use flashlight^nBash him good", User);
		centersay(Message,10,255,0,0);
		say_command(User, Command, sNewVal, 1);			

		snprintf(Text, MAX_TEXT_LENGTH, "mp_flashlight %s", sNewVal);
		exec(Text);
	}
	else
	{
		iNewVal = 1;
		numtostr(iNewVal, sNewVal)
		
		snprintf(Message, MAX_TEXT_LENGTH, "%s has turned on your ability^nto use flashlights^nFlash your opponents to death", User);
		centersay(Message,10,255,0,0);
		say_command(User, Command, sNewVal, 1);

		snprintf(Text, MAX_TEXT_LENGTH, "mp_flashlight %s", sNewVal);
		exec(Text);
	}
	return PLUGIN_HANDLED;
}

public admin_forcechasecam(HLCommand, HLData, HLUserName, UserIndex)
{
	new Command[MAX_COMMAND_LENGTH];
	new User[MAX_NAME_LENGTH];
	new Message[MAX_TEXT_LENGTH];
	new Text[MAX_TEXT_LENGTH];
	new iCurVal = 0;
	new iNewVal = 0;
	new sNewVal[MAX_NUMBER_LENGTH];
	
	convert_string(HLCommand, Command, MAX_COMMAND_LENGTH);
	convert_string(HLUserName,User,MAX_NAME_LENGTH);	
	iCurVal = getvar("mp_forcechasecam");

	if (iCurVal == 1)
	{
		iNewVal = 0;
		numtostr(iNewVal, sNewVal);		

		snprintf(Message, MAX_TEXT_LENGTH, "%s has turned off forced chase cam^nWatch your opponent", User);
		centersay(Message,10,255,0,0);
		say_command(User, Command, sNewVal, 1);

		snprintf(Text, MAX_TEXT_LENGTH, "mp_forcechasecam %s", sNewVal);
		exec(Text);
	}
	else
	{
		iNewVal = 1;
		numtostr(iNewVal, sNewVal)
		
		snprintf(Message, MAX_TEXT_LENGTH, "%s has turned on forced chase cam^nWatch your teammates back", User);
		centersay(Message,10,255,0,0);
		say_command(User, Command, sNewVal, 1);

		snprintf(Text, MAX_TEXT_LENGTH, "mp_forcechasecam %s", sNewVal);
		exec(Text);
	}
	return PLUGIN_HANDLED;
}

public plugin_init()
{
	plugin_registerinfo("Change cvars Plugin", "turn footsteps, force chase cam, or flashlight on or off",STRING_VERSION);
#if ENABLE_FOOTSTEPS==1
	plugin_registercmd("admin_footsteps", "admin_footsteps" , ACCESS_FOOTSTEPS, "admin_footsteps: Changes value of mp_footsteps from 1 to 0 or 0 to 1.");
#endif
#if ENABLE_FLASHLIGHT==1
	plugin_registercmd("admin_flashlight", "admin_flashlight", ACCESS_FLASHLIGHT, "admin_flashlight: Changes value of mp_flashlight from 1 to 0 or 0 to 1.");
#endif
#if ENABLE_FORCECHASECAM==1
	plugin_registercmd("admin_forcechasecam", "admin_forcechasecam", ACCESS_FORCECHASECAM, "admin_forcechasecam: Changes value of mp_forcechasecam from 1 to 0 or 0 to 1.");
#endif

	return PLUGIN_CONTINUE;
}